#!/usr/bin/php
<?php
//**** A "Hello World" for grabbing Google Voice Transcripts from Gmail.
include("Net/IMAPProtocol.php"); 
include("Net/IMAP.php");

//Gmail Settings.  Replace with your account info
$mailbox_username = "xxx@gmail.com";
$mailbox_password = "xxxx";

$mailbox_hostname = "ssl://imap.gmail.com";
$mailbox_port = 993; // SSL
$print_output = true;
	
	//strip out the google voice transcript
	function transcript($rawBody){
		$begin=strpos($rawBody, "Transcript:");
		$end=strpos($rawBody,"Play message:");
		//echo($begin."  ".$end."\n");
		if($begin >0 && $end > 0) {
			$retStr = substr($rawBody,$begin+12, $end-$begin-12);
		} else {
			$retStr = $rawBody;
		}
		return $retStr;
	
	}
	// Create a IMAP Object
	$imap = &new Net_IMAP();
	
	// Connect to the mail box
	if ($imap->connect($mailbox_hostname, $mailbox_port))
	{
		// Tell the user we are connected
		if ($print_output)
		{
			echo "Connected to $mailbox_hostname\n";
		}

		// Log in to the mail box
		if ($imap->login($mailbox_username, $mailbox_password))
		{
			// Tell the user we are logged in
			if ($print_output)
			{
				echo "Logged in to $mailbox_hostname\n";
			}
		
			// Go through the messages
			// Messages start at index 1
			for ($i = 1; $i <= $imap->numMsg(); $i++)
			{
							// Check if new message
				$newMessage = $imap->isSeen($i);
								//echo ($newMessage."\n");
				// If they are allowed, keep going
				if (!$newMessage)
				{
				// Tell the user which message we are on
				if ($print_output)
				{
					echo "Message number: $i\n";
				}
					// Tell the user we have an unseen message
					if ($print_output)
					{
						echo "Message from " . $from['host'] . " is unseen\n";
					}
					// Get the message itself
					$message_text = transcript($imap->getBody($i));
					if ($message_text == "" || $message_text === false)
					{
						$message_text = "";
						if ($message_text === false)
						{
						   $message_text = "";
						}
					}

					if ($print_output) echo "body: $message_text\n";
					}
}
}
}
?>